diff --git a/antispam-plugin.h b/antispam-plugin.h
index df59e88..f446e67 100644
--- a/antispam-plugin.h
+++ b/antispam-plugin.h
@@ -1,6 +1,8 @@
 #ifndef _ANTISPAM_PLUGIN_H
 #define _ANTISPAM_PLUGIN_H
 
+#include <stdlib.h>
+
 #include "lib.h"
 #include "str.h"
 #include "client.h"
@@ -116,7 +118,13 @@ o_stream_create_from_fd(int fd, pool_t pool ATTR_UNUSED)
 static inline struct dict *
 string_dict_init(const char *uri, const char *username)
 {
+#if DOVECOT_VERSION >= DOVECOT_VERSION_CODE(1,2)
+	i_assert(getenv("BASE_DIR"));
+	return dict_init(uri, DICT_DATA_TYPE_STRING, username
+	 , getenv("BASE_DIR"));
+#else
 	return dict_init(uri, DICT_DATA_TYPE_STRING, username);
+#endif
 }
 #elif DOVECOT_VERSION_CODE(1, 0) == DOVECOT_VERSION
 #define ME(err)
